#include <QGuiApplication>
#include <QQmlApplicationEngine>

int main(int argc, char *argv[])
{
    QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);

    QGuiApplication app(argc, argv);

    QList<QQmlError> qmlWarnings;

    QQmlApplicationEngine engine;
    const QUrl url(QStringLiteral("qrc:/main.qml"));
    QObject::connect(&engine, &QQmlApplicationEngine::objectCreated,
                     &app, [url](QObject *obj, const QUrl &objUrl) {
        if (!obj && url == objUrl)
            QCoreApplication::exit(-1);
    }, Qt::QueuedConnection);
    QObject::connect(&engine, &QQmlApplicationEngine::warnings,
                     &app, [&qmlWarnings](const QList<QQmlError> &warnings)
    {
        qmlWarnings.append(warnings);
    });
    engine.load(url);

    auto result = app.exec();

    // oops, it fails, because we never get QQmlApplicationEngine::warnings signal
    Q_ASSERT(!qmlWarnings.empty());

    return result;
}
